import java.rmi.Naming;
public class Client {
  public static void main(String[] args) {
    if(args.length<4) {
      System.err.println("Utilisation : java Client id pass opration "
			 +"mot [dfinition]");
      System.exit(1);
    }
    try {
      IServeur serveur=(IServeur) 
	Naming.lookup("//localhost/dico");
      Utilisateur user=new Utilisateur(args[0],args[1]);
      IDictionnaire dico=serveur.connexion(user);
      if(dico==null) {
	System.err.println("Problme de connexion : pas de dictionnaire");
	System.exit(1);
      }
      if(args[2].equals("dfinition")) {
	String s=dico.dfinition(args[3]);
	if(s==null) {
	  System.err.println("Mot non dfini : "+args[3]);
	} else {
	  System.out.println(args[3]+"=\""+s+'"');
	}
      } else if(args[2].equals("ajout")) {
	if(args.length!=5) {
	  System.err.println("Argument manquant pour l'ajout");
	  System.exit(1);
	}
	dico.ajoute(args[3],args[4]);
      } else if(args[2].equals("suppression")) {
	dico.supprime(args[3]);
      } else {
	System.err.println("Commande inconnue : "+args[2]);
      }
    } catch (Exception e) {
      System.err.println("Erreur RMI : "+e);
    }
  }
}
