import java.rmi.*;
public class Client {
  public static final int MAX_RETRY=10;
  public static void main(String[] args) {
    boolean getObjectAgain;
    do {
      getObjectAgain=false;
      IRandomSelect rng=null;
      int essai=0;
      do {
	boolean sleep=false;
	essai++;
	try {
	  rng=(IRandomSelect)Naming.lookup("//localhost/random");
	} catch(RemoteException e) {
	  System.err.println("Connexion impossible au registry "+e.getMessage());
	  sleep=true;
	} catch(NotBoundException e) {
	  System.err.println("random n'est pas associ  un objet RMI");
	  sleep=true;
	} catch (Exception e) {
	  // vraie erreur
	  System.err.println("Erreur : "+e);
	  System.exit(1);
	}
	if(essai<MAX_RETRY && sleep) {
	  System.err.println("Pause de 5 secondes avant une nouvelle tentative");
	  try {
	    Thread.sleep(5000);
	  } catch (InterruptedException e) {
	    System.err.println("Uh : "+e);
	  }
	}
      } while(essai<MAX_RETRY && rng==null);
      if(rng==null) {
	System.err.println("Impossible de se connecter au serveur");
	System.exit(1);
      }
      System.out.println("Object distant rcupr");
      essai=0;
      boolean retry=true;
      do {
	boolean sleep=false;
	essai++;
	try {
	  System.out.println(rng.random(new int[] {1,2,3},5));
	  retry=false;
	} catch(ArrayIndexOutOfBoundsException e) {
	  System.err.println("Argh: "+e);
	  System.exit(1);
	} catch (ConnectException e) {
	  System.err.println("Connexion refuse (!)");
	  sleep=true;
	  getObjectAgain=true;
	  retry=false;
	} catch (RemoteException e) {
	  System.err.println("Exception RMI : "+e);
	  sleep=true;
	}
	if(essai<MAX_RETRY && sleep) {
	  System.err.println("Pause de 5 secondes avant une nouvelle tentative");
	  try {
	    Thread.sleep(5000);
	  } catch (InterruptedException e) {
	    System.err.println("Uh : "+e);
	  }
	}    
      } while(retry && essai<MAX_RETRY);
      if(retry) {
	System.err.println("Impossible d'utiliser l'objet distant");
	System.exit(1);
      }
    } while(getObjectAgain);
  }
}
