import java.rmi.*;
import java.rmi.server.*;
public class RandomSelectServer {
  public static final int MAX_RETRY=10;
  public static void main(String[] args) {
    RandomSelect server=null;
    int essai=0;
    do {
      essai++;
      try {
	server=new RandomSelect();
      } catch (ExportException e) {
	System.err.println("Impossible d'exporter le serveur : "+e);
      } catch (RemoteException e) {
	System.err.println("Exception RMI : "+e);
      }
      if(essai<MAX_RETRY && server==null) {
	System.err.println("Pause de 5 secondes avant une nouvelle tentative");
	try {
	  Thread.sleep(5000);
	} catch (InterruptedException e) {
	  System.err.println("Uh : "+e);
	}
      }
    } while(essai<MAX_RETRY && server==null);
    boolean retry=false;
    essai=0;
    do {
      essai++;
      try {
	Naming.rebind("//localhost/random",server);
	retry=false;
      } catch(RemoteException e) {
	System.err.println("Connexion impossible au registry "+e.getMessage());
	retry=true;
      } catch (Exception e) {
	  // vraie erreur
	  System.err.println("Erreur : "+e);
	  System.exit(1);
      }
      if(retry) {
	System.err.println("Pause de 5 secondes avant une nouvelle tentative");
	try {
	  Thread.sleep(5000);
	} catch (InterruptedException e) {
	  System.err.println("Uh : "+e);
	}
      }
    } while(essai<MAX_RETRY && retry);
  }
}
